module mat_cmplx_vecp
  use la_precision, only: WP=>DP
  use mat_cmplx

  type, extends(matrice_cmplx) :: matrice_cmplx_vecp
    !private
    complex(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
  contains
    procedure :: propres => propres_cmplx_vecp
    procedure :: sorties => sorties_cmplx_vecp
  end type matrice_cmplx_vecp

  interface matrice_cmplx_vecp
    module function matrice_cmplx_vecp_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_cmplx_vecp)     :: matrice_cmplx_vecp_f
    end function matrice_cmplx_vecp_f
  end interface matrice_cmplx_vecp

  interface
    module subroutine propres_cmplx_vecp(this)
      class(matrice_cmplx_vecp), intent(inout) :: this
    end subroutine propres_cmplx_vecp
    module subroutine sorties_cmplx_vecp(this, init)
      class(matrice_cmplx_vecp), intent(in) :: this
      logical, optional, intent(in)         :: init
    end subroutine sorties_cmplx_vecp
  end interface
end module mat_cmplx_vecp
