module mat_real_sym_vecp
  use la_precision, only: WP=>DP
  use mat_real_sym

  type, extends(matrice_reelle_sym) :: matrice_reelle_sym_vecp
    !private
    real(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = "(*(:,es10.3, 2x))"
  contains
    procedure :: propres => propres_reelle_sym_vecp
    procedure :: sorties => sorties_reelle_sym_vecp
  end type matrice_reelle_sym_vecp

  interface matrice_reelle_sym_vecp
    module function matrice_reelle_sym_vecp_f(fichier)
      character(len=*), intent(in)  :: fichier
      type(matrice_reelle_sym_vecp) :: matrice_reelle_sym_vecp_f
    end function matrice_reelle_sym_vecp_f
  end interface matrice_reelle_sym_vecp

  interface
    module subroutine propres_reelle_sym_vecp(this)
      class(matrice_reelle_sym_vecp), intent(inout) :: this
    end subroutine propres_reelle_sym_vecp
    module subroutine sorties_reelle_sym_vecp(this, init)
      class(matrice_reelle_sym_vecp), intent(in) :: this
      logical, optional, intent(in)              :: init
    end subroutine sorties_reelle_sym_vecp
  end interface
end module mat_real_sym_vecp
