submodule(mat_real_sym) smat_real_sym
  use la_precision, only: WP=>DP
  use f95_lapack,   only: SYEV => LA_SYEV
  implicit none

contains

  module function matrice_reelle_sym_f(fichier)
    character(len=*), intent(in) :: fichier
    type(matrice_reelle_sym)     :: matrice_reelle_sym_f

    matrice_reelle_sym_f%matrice_reelle = matrice_reelle(fichier)
  end function matrice_reelle_sym_f

  module subroutine propres_reelle_sym(this)
    class(matrice_reelle_sym), intent(inout) :: this
    REAL(WP), ALLOCATABLE :: w(:)
    integer n

    n = this%get_ordre()
    allocate(w(n))
    call syev(this%mat, w, UPLO='L')
    this%valp(:) = w(:)
    deallocate(w)
  end subroutine propres_reelle_sym
end submodule smat_real_sym
