module mat_real_vecp
  use la_precision, only: WP=>DP
  use mat_real

  type, extends(matrice_reelle) :: matrice_reelle_vecp
    !private
    complex(kind=WP), dimension(:,:), allocatable :: vecp
    character(len=100) :: format_sortie_vecp = &
                   '(*(:,"(",f6.3,",",f6.3,")",1x))'
  contains
    procedure :: propres => propres_reelle_vecp
    procedure :: sorties => sorties_reelle_vecp
  end type matrice_reelle_vecp

  interface matrice_reelle_vecp
    module function matrice_reelle_vecp_f(fichier)
      character(len=*), intent(in) :: fichier
      type(matrice_reelle_vecp)    :: matrice_reelle_vecp_f
    end function matrice_reelle_vecp_f
  end interface matrice_reelle_vecp

  interface
    module subroutine propres_reelle_vecp(this)
      class(matrice_reelle_vecp), intent(inout) :: this
    end subroutine propres_reelle_vecp
    module subroutine sorties_reelle_vecp(this, init)
      class(matrice_reelle_vecp), intent(in) :: this
      logical, optional, intent(in)          :: init
    end subroutine sorties_reelle_vecp
  end interface
end module mat_real_vecp
