program prog
  use ISO_FORTRAN_ENV
  implicit none
  character(len=:), allocatable :: nom_fichier_acopier, nom_fichier_copie
  character(len=:), allocatable :: nom_executable
  character(len=:), allocatable :: bloc, buffer
  integer taille_bloc, in_unit, out_unit, ios
  namelist /param/ taille_bloc

  ! Rcupration du nom de l'excutable puis du
  ! nom du fichier  copier ainsi que celui du fichier
  !  crer fournis sur la ligne de commande.
  ! Pensez  proposer un "usage" si le nombre des arguments
  ! fourni n'est pas adquate.

  open( newunit=in_unit, &
        file="exo2.nml", &
        action="read",   &
        status="old",    &
        form="formatted" )
  read( unit=in_unit, nml=param )
  close( unit=in_unit )

  open( newunit=in_unit,          &
        file=nom_fichier_acopier, &
        action="read",            &
        status="old",             &
        form="formatted" )

  open( newunit=out_unit,       &
        file=nom_fichier_copie, &
        action="write",         &
        status="replace",       &
        form="formatted" )

  write( OUTPUT_UNIT, * ) &
         "La lecture s'effectuera avec des blocs de ", &
          taille_bloc, "octets."
  allocate( character(len=taille_bloc):: bloc )
  do
    ios = lire_enreg( ZONE=buffer )
    if ( is_iostat_end( ios ) ) exit
    write( unit=out_unit, fmt='(a)' ) trim(buffer)
  end do
  close( unit=in_unit )
  close( unit=out_unit )
CONTAINS
  ! Ecriture de la fonction "lire_enreg" laquelle
  ! valorise son argument avec le contenu d'un
  ! enregistrement complet.
  ! Cette fonction retourne l'tat de la lecture.
  !    ...
!
  ! Ecriture de la procdure "usage" appel lorsque
  ! le nombre d'arguments sur la ligne de commandes
  ! est invalide.
  !    ...
end program prog
